#include <Xm/Xm.h>
#include <Xm/SelectioB.h>
#include <Xm/MessageB.h>
#include <Xm/RowColumn.h>
#include <Xm/ToggleBG.h>
#include <Xm/TextF.h>
#include "global.h"
#include "nrc/nrc.h"

void e_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  GC             gc;
  Display        *dpy=XtDisplay(drawing_a);
  Window         window=XtWindow(drawing_a);
  Dimension      wd, ht;
  static Widget  aucbox;
  Widget         mbox, toggle_box;
  static Widget  tb[5], tfield;
  Arg            args[5];
  int            item, x, x1, x2, xmin, xmax, nactive, chn;
  int            i, j, yunits, yoff, yd;
  float          yf, mean, auc, ymin, ymax, tdif;
  float          ave, adev, sdev, var, skew, curt;
  unsigned long  n, na, ne, n1, n2;
  char           text[100];

  extern void set_color(Widget widget, String fgcolor, String bgcolor, GC gc);
  extern void da_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void cancel_cb(Widget, XtPointer, XtPointer);
  extern void showmess(Widget widget, char *title, char *text);
  void toggle_cb(Widget tb, XtPointer client_data, XtPointer call_data);
  void artifact_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void arti_cancel_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void auc_cb(Widget w, XtPointer client_data, XtPointer call_data);

  gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  XtVaGetValues(drawing_a, XmNwidth, &wd, XmNheight, &ht, NULL);
  x1=LMAR+(int)((r.ts_1-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
  x2=LMAR+(int)((r.ts_2-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
  item=(int) client_data;
  switch(item) {
  case 0:      // mean;
    if (r.nvis>0) {
      set_color(drawing_a, "blue", NULL, gc);
      XDrawLine(dpy, window, gc, x1, 0, x1, ht);
      XDrawLine(dpy, window, gc, x2, 0, x2, ht);
      set_color(drawing_a, "black", NULL, gc);
      yunits=0;
      for (i=0; i<r.n; i++)
	if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
      yoff=0;
      for (i=0; i<r.n; i++) {
	if(r.view[i].is_visible) {
	  yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	  yoff+=yd;
	  yf=(float)yd/(r.view[i].max-r.view[i].min);
	  na=(unsigned long)(r.ts_1*r.ch[i].sr);
	  if (na>=r.ch[i].n) na=r.ch[i].n-1;
	  ne=(unsigned long)(r.ts_2*r.ch[i].sr);
	  if (ne>=r.ch[i].n) ne=r.ch[i].n-1;
	  if (ne>na) {
	    mean=0;
	    for (n=na; n<=ne; n++) mean+=r.ch[i].data[n];
	    mean=mean/(ne-na+1);
	    sprintf(text,"%.2f",mean);
	    set_color(drawing_a, "blue", NULL, gc);
	    XDrawLine(dpy, window, gc,
		  x1, (int)(yoff-yf*(mean-r.view[i].min)),
		  x2, (int)(yoff-yf*(mean-r.view[i].min)));
	    set_color(drawing_a, "black", "White", gc);
	    XDrawImageString(dpy, window, gc, x1, yoff-yd+15, text, strlen(text));
	  }
	}
      }
    }
    break;
  case 1:      // area under the curve;
    // check whether at least one channel is active;
    nactive=0; 
    for (i=0; i<r.n; i++) {
      if (r.view[i].is_active && r.view[i].is_visible) {
	nactive++;
      }
    }
    if (r.nvis>0 && nactive>0) {
      // create dialog box;
      if (!aucbox) {
	i=0;
	XtSetArg(args[i], XmNtitle, "area under the curve"); i++;
	XtSetArg(args[i], XmNautoUnmanage, False); i++;
	XtSetArg(args[i], XmNselectionLabelString, XmStringCreateLocalized("Baseline for area under the curve:")); i++;
	XtSetArg(args[i], XmNtextString, XmStringCreateLocalized("0.000")); i++;
	aucbox=XmCreatePromptDialog(drawing_a, "auc", args, i);
	XtUnmanageChild(XmSelectionBoxGetChild(aucbox, XmDIALOG_HELP_BUTTON));
	XtAddCallback(aucbox, XmNokCallback, auc_cb, NULL);
	XtAddCallback(aucbox, XmNcancelCallback, cancel_cb, NULL);
      }
      XtManageChild(aucbox);
      XtPopup(XtParent(aucbox), XtGrabNone);
    }
    else {
      showmess(drawing_a, "area under the curve", "At least one channel must be active!");
    }
    break;
  case 2:      // minimum;
    if (r.nvis>0) {
      set_color(drawing_a, "blue", NULL, gc);
      XDrawLine(dpy, window, gc, x1, 0, x1, ht);
      XDrawLine(dpy, window, gc, x2, 0, x2, ht);
      set_color(drawing_a, "black", NULL, gc);
      yunits=0;
      for (i=0; i<r.n; i++)
	if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
      yoff=0;
      for (i=0; i<r.n; i++) {
	if(r.view[i].is_visible) {
	  yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	  yoff+=yd;
	  yf=(float)yd/(r.view[i].max-r.view[i].min);
	  na=(unsigned long)(r.ts_1*r.ch[i].sr);
	  if (na>=r.ch[i].n) na=r.ch[i].n-1;
	  ne=(unsigned long)(r.ts_2*r.ch[i].sr);
	  if (ne>=r.ch[i].n) ne=r.ch[i].n-1;
	  if (ne>na) {
	    ymin=r.ch[i].data[na]; n1=na;
	    for (n=na; n<=ne; n++)
	      if (ymin>r.ch[i].data[n]) {
		ymin=r.ch[i].data[n];
		n1=n;
	      }
	    sprintf(text,"%.2f",ymin);
	    set_color(drawing_a, "blue", NULL, gc);
	    x=LMAR+(int)(((float)n1/r.ch[i].sr-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	    XDrawArc(dpy, window, gc,
		  x-5, yoff-5-(int)(yf*(ymin-r.view[i].min)),
		  10, 10, 0, 360*64);
	    set_color(drawing_a, "black", "White", gc);
	    XDrawImageString(dpy, window, gc, x1, yoff-yd+15, text, strlen(text));
	  }
	}
      }
    }
    break;
  case 3:      // maximum;
    if (r.nvis>0) {
      set_color(drawing_a, "blue", NULL, gc);
      XDrawLine(dpy, window, gc, x1, 0, x1, ht);
      XDrawLine(dpy, window, gc, x2, 0, x2, ht);
      set_color(drawing_a, "black", NULL, gc);
      yunits=0;
      for (i=0; i<r.n; i++)
	if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
      yoff=0;
      for (i=0; i<r.n; i++) {
	if(r.view[i].is_visible) {
	  yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	  yoff+=yd;
	  yf=(float)yd/(r.view[i].max-r.view[i].min);
	  na=(unsigned long)(r.ts_1*r.ch[i].sr);
	  if (na>=r.ch[i].n) na=r.ch[i].n-1;
	  ne=(unsigned long)(r.ts_2*r.ch[i].sr);
	  if (ne>=r.ch[i].n) ne=r.ch[i].n-1;
	  if (ne>na) {
	    ymax=r.ch[i].data[na]; n1=na;
	    for (n=na; n<=ne; n++)
	      if (ymax<r.ch[i].data[n]) {
		ymax=r.ch[i].data[n];
		n1=n;
	      }
	    sprintf(text,"%.2f",ymax);
	    set_color(drawing_a, "blue", NULL, gc);
	    x=LMAR+(int)(((float)n1/r.ch[i].sr-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	    XDrawArc(dpy, window, gc,
		  x-5, yoff-5-(int)(yf*(ymax-r.view[i].min)),
		  10, 10, 0, 360*64);
	    set_color(drawing_a, "black", "White", gc);
	    XDrawImageString(dpy, window, gc, x1, yoff-yd+15, text, strlen(text));
	  }
	}
      }
    }
    break;
  case 4:      // difference;
    if (r.nvis>0) {
      set_color(drawing_a, "blue", NULL, gc);
      XDrawLine(dpy, window, gc, x1, 0, x1, ht);
      XDrawLine(dpy, window, gc, x2, 0, x2, ht);
      set_color(drawing_a, "black", NULL, gc);
      yunits=0;
      for (i=0; i<r.n; i++)
	if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
      yoff=0;
      for (i=0; i<r.n; i++) {
	if(r.view[i].is_visible) {
	  yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	  yoff+=yd;
	  yf=(float)yd/(r.view[i].max-r.view[i].min);
	  na=(unsigned long)(r.ts_1*r.ch[i].sr);
	  if (na>=r.ch[i].n) na=r.ch[i].n-1;
	  ne=(unsigned long)(r.ts_2*r.ch[i].sr);
	  if (ne>=r.ch[i].n) ne=r.ch[i].n-1;
	  if (ne>na) {
	    ymin=r.ch[i].data[na]; n1=na;
	    ymax=r.ch[i].data[na]; n2=na;
	    for (n=na; n<=ne; n++) {
	      if (ymin>r.ch[i].data[n]) {
		ymin=r.ch[i].data[n]; n1=n;
	      }
	      if (ymax<r.ch[i].data[n]) {
		ymax=r.ch[i].data[n]; n2=n;
	      }
	    }
	    sprintf(text,"%.2f",ymax-ymin);
	    set_color(drawing_a, "blue", NULL, gc);
	    xmin=LMAR+(int)(((float)n1/r.ch[i].sr-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	    xmax=LMAR+(int)(((float)n2/r.ch[i].sr-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	    XDrawArc(dpy, window, gc,
		  xmin-5, yoff-5-(int)(yf*(ymin-r.view[i].min)),
		  10, 10, 0, 360*64);
	    XDrawArc(dpy, window, gc,
		  xmax-5, yoff-5-(int)(yf*(ymax-r.view[i].min)),
		  10, 10, 0, 360*64);
	    XDrawLine(dpy, window, gc,
		      xmin,yoff-(int)(yf*(ymin-r.view[i].min)),
		      xmax,yoff-(int)(yf*(ymin-r.view[i].min)));
	    XDrawLine(dpy, window, gc,
		      xmax,yoff-(int)(yf*(ymin-r.view[i].min)),
		      xmax,yoff-(int)(yf*(ymax-r.view[i].min)));
	    set_color(drawing_a, "black", "White", gc);
	    XDrawImageString(dpy, window, gc, x1, yoff-yd+15, text, strlen(text));
	  }
	}
      }
    }
    break;
  case 5:      // artifact;
    // check whether one channel is active;
    nactive=0; yunits=0; chn=-1;
    for (i=0; i<r.n; i++) {
      if (r.view[i].is_active && r.view[i].is_visible) {
	nactive++;
	if (chn<0) chn=i;
      }
      if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
    }
    if (r.nvis>0 && nactive==1) {
      // create dialog box;
      i=0;
      XtSetArg(args[i], XmNtitle, "artifact removal"); i++;
      XtSetArg(args[i], XmNautoUnmanage, False); i++;
      mbox=XmCreateMessageDialog(drawing_a, "artiremove", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_HELP_BUTTON));
      // create rowcolumn widget;
      toggle_box=XtVaCreateWidget("togglebox",
				  xmRowColumnWidgetClass, mbox,
				  XmNpacking, XmPACK_COLUMN,
				  XmNnumColumns, 2,
				  NULL);
      // create and set toggles for spline (0) or linear (1);
      tb[0]=XtVaCreateManagedWidget("spline", xmToggleButtonGadgetClass, toggle_box, NULL);
      tb[1]=XtVaCreateManagedWidget("linear", xmToggleButtonGadgetClass, toggle_box, NULL);
      tb[4]=XtVaCreateManagedWidget("automatic", xmToggleButtonGadgetClass, toggle_box, NULL);
      // create and set toggles for test (2) or real (3);
      tb[2]=XtVaCreateManagedWidget("test", xmToggleButtonGadgetClass, toggle_box, NULL);
      tb[3]=XtVaCreateManagedWidget("real", xmToggleButtonGadgetClass, toggle_box, NULL);
      tfield=XtVaCreateManagedWidget("tf", xmTextFieldWidgetClass, toggle_box, NULL);
      moment(r.ch[chn].data, r.ch[chn].n, &ave, &adev, &sdev, &var, &skew, &curt);
      sprintf(text, "%f", sdev);
      XmTextFieldSetString(tfield, text);
      XtVaSetValues(mbox, XmNuserData, tfield, NULL);
      XtAddCallback(tb[0], XmNvalueChangedCallback, toggle_cb, tb[1]);
      XtAddCallback(tb[1], XmNvalueChangedCallback, toggle_cb, tb[0]);
      XtAddCallback(tb[2], XmNvalueChangedCallback, toggle_cb, tb[3]);
      XtAddCallback(tb[3], XmNvalueChangedCallback, toggle_cb, tb[2]);
      XmToggleButtonGadgetSetState(tb[0],True,False);
      XmToggleButtonGadgetSetState(tb[1],False,False);
      XmToggleButtonGadgetSetState(tb[2],True,False);
      XmToggleButtonGadgetSetState(tb[3],False,False);
      XtAddCallback(mbox, XmNokCallback, artifact_cb, tb);
      XtAddCallback(mbox, XmNcancelCallback, arti_cancel_cb, NULL);
      XtManageChild(toggle_box);
      XtManageChild(mbox);
      XtSetSensitive(mymenu.calc.artifact,False);
      XtPopup(XtParent(mbox), XtGrabNone);
    }
    else {
      showmess(drawing_a, "artifact removal", "Exactly 1 channel must be active!");
    }
    break;
  case 6:  // copy channels;
    // check whether one channel is active;
    nactive=0;
    for (i=0; i<r.n; i++)
      if (r.view[i].is_active && r.view[i].is_visible) nactive++;
    // if at least one channel is active -> copy;
    if (r.nvis>0 && nactive>0) {
      j=r.n;
      for (i=0; i<j; i++) {
	if(r.view[i].is_visible && r.view[i].is_active) {
	  r.AddChannel(r.ch[i].n, r.ch[i].sr, r.ch[i].min, r.ch[i].max,
		       r.ch[i].height, r.ch[i].color,
		       r.ch[i].name, r.ch[i].unit);
	  for (n=0; n<r.ch[i].n; n++) r.ch[r.n-1].data[n]=r.ch[i].data[n];
	  r.view[r.n-1].is_active=0;
	  r.view[r.n-1].is_frequency=r.view[i].is_frequency;
	  na=(unsigned long)(r.t_1*r.ch[r.n-1].sr);
	  if (na>=r.ch[r.n-1].n) na=r.ch[r.n-1].n-1;
	  ne=(unsigned long)(r.t_2*r.ch[r.n-1].sr);
	  if (ne>=r.ch[r.n-1].n) ne=r.ch[r.n-1].n-1;
	  r.view[r.n-1].min=1e30; r.view[r.n-1].max=-1e30;
	  for (n=na; n<=ne; n++) {
	    if (r.view[r.n-1].min > r.ch[r.n-1].data[n])
	      r.view[r.n-1].min=r.ch[r.n-1].data[n];
	    if (r.view[r.n-1].max < r.ch[r.n-1].data[n])
	      r.view[r.n-1].max=r.ch[r.n-1].data[n];
	  } /* endfor */
	} /* endif */
      } /* endfor */
      da_cb(NULL, NULL, NULL);
    } /* endif */
    else {
      // Report error;
      i=0;
      XtSetArg(args[i], XmNmessageString, XmStringCreateLtoR("At least 1 channel must be active!",XmFONTLIST_DEFAULT_TAG)); i++;
      XtSetArg(args[i], XmNtitle, "Copy Channels"); i++;
      mbox=XmCreateMessageDialog(drawing_a, "Error", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_HELP_BUTTON));
      XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_CANCEL_BUTTON));
      XtManageChild(mbox);
    }
    break;
  case 7:  // delete channels;
    // check whether one channel is active;
    nactive=0;
    for (i=0; i<r.n; i++)
      if (r.view[i].is_active && r.view[i].is_visible) nactive++;
    // if at least one channel is active -> delete;
    if (r.nvis>0 && nactive>0) {
      for (i=0; i<r.n; i++)
	if(r.view[i].is_visible && r.view[i].is_active) {
	  r.DelChannel(i);
	  i--;
	}
      da_cb(NULL, NULL, NULL);
    } /* endif */
    else {
      // Report error;
      i=0;
      XtSetArg(args[i], XmNmessageString, XmStringCreateLtoR("At least 1 channel must be active!",XmFONTLIST_DEFAULT_TAG)); i++;
      XtSetArg(args[i], XmNtitle, "Delete Channels"); i++;
      mbox=XmCreateMessageDialog(drawing_a, "Error", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_HELP_BUTTON));
      XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_CANCEL_BUTTON));
      XtManageChild(mbox);
    }
    break;
  case 8:  // reduce to visible;
    for (i=0; i<r.n; i++) if (!r.view[i].is_visible) r.DelChannel(i);
    for (i=0; i<r.n; i++) {
      if (r.view[i].is_visible) {
	n1=(unsigned long)(r.t_1*r.ch[i].sr);
	if (n1<0) n1=0;
	if (n1>=r.ch[i].n) n1=r.ch[i].n-1;
	n2=(unsigned long)(r.t_2*r.ch[i].sr);
	if (n2>=r.ch[i].n) n2=r.ch[i].n-1;
	if (n2<0) n2=0;
	if (n2>n1) {
	  for (n=n1; n<=n2; n++) r.ch[i].data[n-n1]=r.ch[i].data[n];
	  r.ch[i].data=(float *)realloc(r.ch[i].data, (n2-n1+1)*sizeof(float));
	  r.ch[i].n=n2-n1+1;
	  r.ch[i].min=r.view[i].min;
	  r.ch[i].max=r.view[i].max;
	}
	else {
	  r.DelChannel(i);
	  i--;
	}
      }
      else {
	r.DelChannel(i);
	i--;
      }
    }
    r.t_1=0; r.t_2=0;
    for (i=0; i<r.n; i++) {
      if (r.view[i].is_visible)
	if (r.t_2 < r.ch[i].n/r.ch[i].sr) r.t_2=r.ch[i].n/r.ch[i].sr;
    }
    r.ts_1=r.t_1; r.ts_2=r.t_2;
    break;
  case 9:      // deltaX;
    if (r.nvis>0) {
      set_color(drawing_a, "blue", NULL, gc);
      XDrawLine(dpy, window, gc, x1, 0, x1, ht);
      XDrawLine(dpy, window, gc, x2, 0, x2, ht);
      set_color(drawing_a, "black", NULL, gc);
      yunits=0;
      for (i=0; i<r.n; i++)
	if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
      yoff=0;
      for (i=0; i<r.n; i++) {
	if(r.view[i].is_visible) {
	  yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	  yoff+=yd;
	  yf=(float)yd/(r.view[i].max-r.view[i].min);
	  tdif=r.ts_2-r.ts_1;

	  if (tdif>0) {
	    sprintf(text,"%.6f",tdif);
	    set_color(drawing_a, "blue", NULL, gc);
	    xmin=LMAR+(int)((r.ts_1-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	    xmax=LMAR+(int)((r.ts_2-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	    XDrawLine(dpy, window, gc,
		      xmin,yoff-(int)(yf*(ymin-r.view[i].min)),
		      xmax,yoff-(int)(yf*(ymin-r.view[i].min)));
	    XDrawLine(dpy, window, gc,
		      xmax,yoff-(int)(yf*(ymin-r.view[i].min)),
		      xmax,yoff-(int)(yf*(ymax-r.view[i].min)));
	    set_color(drawing_a, "black", "White", gc);
	    XDrawImageString(dpy, window, gc, x1, yoff-yd+15, text, strlen(text));
	  }
	}
      }
    }
    break;
  }
  XFreeGC(dpy,gc);
}

/*   .................   */
/*   c a l l b a c k s   */
/*   .................   */

void arti_cancel_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  XtSetSensitive(mymenu.calc.artifact,True);
  XtUnmanageChild(w);
}

void toggle_cb(Widget tb, XtPointer client_data, XtPointer call_data) {
  Widget w=(Widget) client_data;
  XmToggleButtonCallbackStruct
    *toggle_data = (XmToggleButtonCallbackStruct *) call_data;

  if (toggle_data->set) {
    XmToggleButtonGadgetSetState(w,False,False);
  }
  else {
    XmToggleButtonGadgetSetState(w,False,False);
    XmToggleButtonGadgetSetState(tb,True,False);
  }
}

void artifact_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  GC            gc;
  Display       *dpy=XtDisplay(drawing_a);
  Window        window=XtWindow(drawing_a);
  Widget        mbox, *tb, tfield;
  Dimension     ht, wd;
  Arg           args[5];
  int           x1, x2, xx1, xx2;
  unsigned long n, na, ne, nn1, nn2;
  int           i, nactive, yunits, chn;
  int           yoff, yd;
  float         yf, wert1, wert2, delta;

  extern void set_color(Widget widget, String fgcolor, String bgcolor, GC gc);
  extern void da_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void arti_work(int chn, unsigned long na, unsigned long ne, int yoff, float ft, Widget *tb);

  XtVaGetValues(w, XmNuserData, &tfield, NULL);
  sscanf(XmTextFieldGetString(tfield), "%f", &delta);

  gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  XtVaGetValues(drawing_a, XmNwidth, &wd, XmNheight, &ht, NULL);
  tb=(Widget *)client_data;
  x1=LMAR+(int)((r.ts_1-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
  x2=LMAR+(int)((r.ts_2-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
  // check whether one channel and which is active;
  nactive=0; yunits=0; chn=-1;
  for (i=0; i<r.n; i++) {
    if (r.view[i].is_active && r.view[i].is_visible) {
      nactive++;
      if (chn<0) chn=i;
    }
    if (r.view[i].is_visible)
      yunits+=r.ch[i].height+1;
  }

  if (r.nvis>0 && nactive==1 && chn>=0) {
    // artifact removal;
    yoff=0;
    for (i=0; i<=chn; i++) {
      if (r.view[i].is_visible) {
	yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	yoff+=yd;
      }
    }
    yf=(float)yd/(r.view[chn].max-r.view[chn].min);
    na=(unsigned long)(r.ts_1*r.ch[chn].sr);
    if (na>=r.ch[chn].n) na=r.ch[chn].n-1;
    ne=(unsigned long)(r.ts_2*r.ch[chn].sr);
    if (!XmToggleButtonGadgetGetState(tb[4])) { /* manual */
      if (XmToggleButtonGadgetGetState(tb[2])) { /* test */
	set_color(drawing_a, "blue", NULL, gc);
	XDrawLine(dpy, window, gc, x1, yoff, x1, yoff-yd);
	XDrawLine(dpy, window, gc, x2, yoff, x2, yoff-yd);
	set_color(drawing_a, "black", NULL, gc);
      }
      arti_work(chn, na, ne, yoff, yf, tb);
      if (XmToggleButtonGadgetGetState(tb[3])) { /* real */
	da_cb(NULL, NULL, NULL);
	r.ch[chn].max=r.ch[chn].data[0]; r.ch[chn].min=r.ch[chn].data[0];
	for (n=0; n<=r.ch[chn].n; n++) {
	  if (r.ch[chn].data[n]>r.ch[chn].max)  r.ch[chn].max=r.ch[chn].data[n];
	  if (r.ch[chn].data[n]<r.ch[chn].min)  r.ch[chn].min=r.ch[chn].data[n];
	}
      }
    }
    else { /* automatic */
      wert1=r.ch[chn].data[na];
      for (n=na+1; n<=ne; n++) {
	wert2=r.ch[chn].data[n];
	if (fabs(wert2-wert1) > delta) {
	  xx1=LMAR+ (int) ((((float)(n/r.ch[chn].sr) - r.t_1) * (wd-LMAR))/(r.t_2-r.t_1));
	  nn1=n;
	  do
	    wert2=r.ch[chn].data[++n];
	  while ((fabs(wert2-wert1) > delta) && n<ne);
	  if (n<ne) {
	    xx2=LMAR+ (int) ((((float)(n/r.ch[chn].sr) - r.t_1) * (wd-LMAR))/(r.t_2-r.t_1));
	    nn2=n;
	    set_color(drawing_a, "blue", NULL, gc);
	    XDrawLine(dpy, window, gc, xx1, yoff, xx1, yoff-yd);
	    XDrawLine(dpy, window, gc, xx2, yoff, xx2, yoff-yd);
	    set_color(drawing_a, "black", NULL, gc);
	    arti_work(chn, nn1-1, nn2, yoff, yf, tb);
	  }
	}
	wert1=wert2;
      }
      if (XmToggleButtonGadgetGetState(tb[3])) { /* real */
	da_cb(NULL, NULL, NULL);
	r.ch[chn].max=r.ch[chn].data[0]; r.ch[chn].min=r.ch[chn].data[0];
	for (n=0; n<=r.ch[chn].n; n++) {
	  if (r.ch[chn].data[n]>r.ch[chn].max)  r.ch[chn].max=r.ch[chn].data[n];
	  if (r.ch[chn].data[n]<r.ch[chn].min)  r.ch[chn].min=r.ch[chn].data[n];
	}
      }
    }
  }
  else {
    // error message;
    i=0;
    XtSetArg(args[i], XmNmessageString, XmStringCreateLtoR("Exactly 1 channel must be active!",XmFONTLIST_DEFAULT_TAG)); i++;
    XtSetArg(args[i], XmNtitle, "artifact removal"); i++;
    mbox=XmCreateMessageDialog(drawing_a, "Error", args, i);
    XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_CANCEL_BUTTON));
    XtManageChild(mbox);
  }
  XFreeGC(dpy,gc);
}

void arti_work(int chn, unsigned long na, unsigned long ne, int yoff, float yf, Widget *tb) {
  GC            gc;
  Display       *dpy=XtDisplay(drawing_a);
  Window        window=XtWindow(drawing_a);
  Dimension     ht, wd;
  unsigned long n, n1, n2;
  float         *xval, *yval, *y2, *ysp;
  int           nsp=3, i, x1, x2;
  float         ymax, ymin, wert, m, b;

  extern void set_color(Widget widget, String fgcolor, String bgcolor, GC gc);
  extern void da_cb(Widget widget, XtPointer client_data, XtPointer call_data);

  gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  XtVaGetValues(drawing_a, XmNwidth, &wd, XmNheight, &ht, NULL);
  x1= LMAR+ (int) ((((float)(na/r.ch[chn].sr) - r.t_1) * (wd-LMAR))/(r.t_2-r.t_1));
  x2= LMAR+ (int) ((((float)(ne/r.ch[chn].sr) - r.t_1) * (wd-LMAR))/(r.t_2-r.t_1));
  if (ne>=r.ch[chn].n) ne=r.ch[chn].n-1;
  if (ne>na) {
    xval=new float[2*nsp];
    y2  =new float[2*nsp];
    yval=new float[2*nsp];
    ysp =new float[ne-na-1];
    m=(r.ch[chn].data[ne]-r.ch[chn].data[na])/
      ((ne-na)/r.ch[chn].sr);
    b=r.ch[chn].data[na]-(m*na/r.ch[chn].sr);
    for (n=na-nsp+1; n<=na; n++) {
      xval[n-(na-nsp+1)]=(float)n/r.ch[chn].sr;
      if (XmToggleButtonGadgetGetState(tb[0])) /* spline */
	yval[n-(na-nsp+1)]=r.ch[chn].data[n];
      if (XmToggleButtonGadgetGetState(tb[1])) /* linear */
	yval[n-(na-nsp+1)]=m*n/r.ch[chn].sr+b;
    }
    for (n=ne; n<ne+nsp; n++) {
      xval[n-ne+nsp]=(float)n/r.ch[chn].sr;
      if (XmToggleButtonGadgetGetState(tb[0])) /* spline */
	yval[n-ne+nsp]=r.ch[chn].data[n];
      if (XmToggleButtonGadgetGetState(tb[1])) /* linear */
	yval[n-ne+nsp]=m*n/r.ch[chn].sr+b;
    }
    spline(xval-1,yval-1,2*nsp, 1e30, 1e30, y2-1);
    for (n=na+1; n<ne; n++) {
      splint(xval-1, yval-1, y2-1, 2*nsp, (float)n/r.ch[chn].sr, &wert);
      if (XmToggleButtonGadgetGetState(tb[2])) // test
	ysp[n-na-1]=wert;
      if (XmToggleButtonGadgetGetState(tb[3])) // real
	r.ch[chn].data[n]=wert;
    }
    if (XmToggleButtonGadgetGetState(tb[2])) { /* test */
      set_color(drawing_a, "red", NULL, gc);
      n2=na;
      for (i=x1; i<=x2; i++) {
	n1=n2;
	if (n1<0) n1=0;
	n2=(unsigned long)((r.t_1*r.ch[chn].sr)+
			   (r.t_2-r.t_1)*r.ch[chn].sr*(i+1-LMAR)/(wd-LMAR));
	if (n1>=r.ch[chn].n) n1=r.ch[chn].n-1;
	if (n1 < 0) n1=0;
	if (n2>=r.ch[chn].n) n2=r.ch[chn].n-1;
	if (n2 < 0) n2=0;
	if (n1>n2) n1=n2;
	if ((n1-na-1)>=0 && (n1-na-1)<(ne-na-1)) {
	  ymax=ysp[n1-na-1];
	  ymin=ysp[n1-na-1];
	}
	else {
	  ymax=r.ch[chn].data[n1];
	  ymin=r.ch[chn].data[n1];
	}
	for (n=n1; n<=n2; n++) {
	  if ((n-na-1)>=0 && (n-na-1)<(ne-na-1)) {
	    if (r.ch[chn].data[n]>ymax) ymax=ysp[n-na-1];
	    if (r.ch[chn].data[n]<ymin) ymin=ysp[n-na-1];
	  }
	  else {
	    if (r.ch[chn].data[n]>ymax) ymax=r.ch[chn].data[n];
	    if (r.ch[chn].data[n]<ymin) ymin=r.ch[chn].data[n];
	  }
	}
	XDrawLine(dpy,window,gc,i,(int)(yoff-yf*(ymin-r.view[chn].min)),
		  i,(int)(yoff-yf*(ymax-r.view[chn].min)));
      }
      set_color(drawing_a, "black", NULL, gc);
    }
    delete [] xval; delete [] yval; delete [] y2; delete [] ysp;
  }
  XFreeGC(dpy,gc);
}

void auc_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  XmSelectionBoxCallbackStruct *cbs;
  GC             gc;
  Display        *dpy=XtDisplay(drawing_a);
  Window         window=XtWindow(drawing_a);
  Dimension      wd, ht;
  int            i, j, x1, x2, nactive, yunits, yoff, yd, chn;
  unsigned long  n, na, ne, n1, n2;
  char           *text, *endptr, auctext[100];
  float          auc, aucbaseline, drawbaseline, yf, ymin, ymax;

  extern void showmess(Widget widget, char *title, char *text);
  extern void set_color(Widget widget, String fgcolor, String bgcolor, GC gc);
  
  gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  XtVaGetValues(drawing_a, XmNwidth, &wd, XmNheight, &ht, NULL);
  x1=LMAR+(int)((r.ts_1-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
  x2=LMAR+(int)((r.ts_2-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));

  /* get aucbaseline */
  cbs=(XmSelectionBoxCallbackStruct *) call_data;
  XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &text);
  aucbaseline=strtod(text, &endptr);
  if (text!=endptr) {  // input was numeric;
    /* how many channels are active ? */
    nactive=0; yunits=0; chn=-1;
    for (i=0; i<r.n; i++) {
      if (r.view[i].is_active && r.view[i].is_visible) {
	nactive++;
	if (chn<0) chn=i;
      }
      if (r.view[i].is_visible)
	yunits+=r.ch[i].height+1;
    }
    
    if (nactive>0 && r.nvis>0) {
      set_color(drawing_a, "blue", NULL, gc);
      XDrawLine(dpy, window, gc, x1, 0, x1, ht);
      XDrawLine(dpy, window, gc, x2, 0, x2, ht);
      set_color(drawing_a, "black", NULL, gc);
      yoff=0;
      for (i=0; i<r.n; i++) {
	if (!r.view[i].is_active && r.view[i].is_visible) {
	  yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	  yoff+=yd;
	}
	if (r.view[i].is_active && r.view[i].is_visible) {
	  drawbaseline=aucbaseline;
	  if (drawbaseline > r.view[i].max) drawbaseline=r.view[i].max;
	  if (drawbaseline < r.view[i].min) drawbaseline=r.view[i].min;
	  yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	  yoff+=yd;
	  yf=(float)yd/(r.view[i].max-r.view[i].min);
	  na=(unsigned long)(r.ts_1*r.ch[i].sr);
	  if (na>=r.ch[i].n) na=r.ch[i].n-1;
	  ne=(unsigned long)(r.ts_2*r.ch[i].sr);
	  if (ne>=r.ch[i].n) ne=r.ch[i].n-1;
	  if (ne>na) {
	    auc=0.0;
	    for (n=na; n<=ne; n++) auc+=r.ch[i].data[n];
	    if (r.view[i].is_frequency) {
	      auc=(auc/(ne-na+1)-aucbaseline)*(ne-na+1)*(r.ch[i].sr/(2*(r.ch[i].n-1)));
	    }
	    else
	      auc=(auc/(ne-na+1)-aucbaseline)*((ne-na+1)/r.ch[i].sr);
	    sprintf(auctext,"%.4f",auc);
	    n2=na;
	    for (j=x1; j<=x2; j++) {
	      n1=n2;
	      if(n1<0) n1=0;
	      n2=(unsigned long)((r.t_1*r.ch[i].sr)+
				 (r.t_2-r.t_1)*r.ch[i].sr*(j+1-LMAR)/(wd-LMAR));
	      if(n2>=r.ch[i].n) n2=r.ch[i].n-1;
	      if(n1>n2) n2=n1;
	      ymax=r.ch[i].data[n1];
	      ymin=r.ch[i].data[n1];
	      for (n=n1; n<=n2; n++) {
		if (r.ch[i].data[n]>ymax) ymax=r.ch[i].data[n];
		if (r.ch[i].data[n]<ymin) ymin=r.ch[i].data[n];
	      }
	      set_color(drawing_a, "blue", NULL, gc);
	      if (ymax>r.ch[i].data[na])
		XDrawLine(dpy, window, gc,
			  j, (int)((float)yoff-yf*(ymax-r.view[i].min)),
			  j, (int)((float)yoff-yf*(drawbaseline-r.view[i].min)));
	      if (ymin<r.ch[i].data[na])
		XDrawLine(dpy, window, gc,
			  j, (int)((float)yoff-yf*(ymin-r.view[i].min)),
			  j, (int)((float)yoff-yf*(drawbaseline-r.view[i].min)));
	    }
	    set_color(drawing_a, "black", "White", gc);
	    XDrawImageString(dpy, window, gc, x1, yoff+15-yd, auctext, strlen(auctext));
	  }
	}
      }
    } /* endif */
    else { // active channels required if aucbaseline != 0.0;
      showmess(w, "area under the curve", "At least 1 channel must be active!");
    }
  }
  else { // input was not numeric;
    showmess(w, "area under the curve", "Value is not numeric!");
  }
  XtFree(text);
  XFreeGC(dpy,gc);
}
